#include <stdlib.h>
#include <fopmo.h>

fopMO::fopMO(Axis & t,Axis & x ) {
    Axislist temp(2);
    temp.list[0] = t; temp.list[1] = x; inaxis = temp;
    outaxis = temp;
}
fopMO::fopMO(Axis & ti,Axis & xi, Axis & to ,Axis & xo ) {
    Axislist temp(2);
    temp.list[0] = ti; temp.list[1] = xi; inaxis = temp;
    temp.list[0] = to; temp.list[1] = xo; outaxis = temp;
}

fopMO::~fopMO() {}

void fopMO::apply(floatArray & in,floatArray & out,int adj, 
		   const Axislist & inlist,const Axislist & outlist) const {
    for (int i=0; i<inlist[1].length; i++) {

	float x = inlist[1].value(i);

	for (int j=0; j<inlist[0].length; j++) {

	    float tau = inlist[0].value(j);

	    int it = outlist[0].index( mapping(tau,x) );

	    if (it < outlist[0].length && it >= 0) {
		if ( adj==0 ) {  // forward == modeling
		    out(it,i) += in(j,i) * weight(tau,x) ;
		} else {         // adjoint == nmo processing
		    in(j,i) += out(it,i) * weight(tau,x);
		}
	    }
	}
    }
}

float fopMO::weight(float tau, float x) const {
   float dataweight = 1.;
   return dataweight;
}
