// fopmo.h
// Operator to perform general MO

#ifndef _OP_MO_
#define _OP_MO_

#include <fopone.h>
#include <farray.h>
#include <Axis.h>
#include <Axislist.h>
#include <math.h>

class fopMO : public fopone {
  public:

    // Constructors for fopMO: parameters are:
    // Time axis,Offset axis, slowness
    // or slowness array with as many samples as the time axis.
    fopMO(Axis & t ,Axis & x );
    fopMO(Axis & ti ,Axis & xi, Axis & to ,Axis & xo );

    ~fopMO();

    // define your moveout curve
    virtual float mapping( float tau, float x ) const = 0 ;

    // define weighting function for data points
    virtual float weight ( float tau, float x ) const ;

    void apply(floatArray &,floatArray &,int, 
		const Axislist &,const Axislist &) const;

	Axislist inlist;
	Axislist outlist;
};

#endif
