#include <fopfmo.h>


fopFMO::fopFMO(Axis & t , Axis & x, float slow, float ff): 
	fopMAP( t, x, slow ) { ffn=ff; } 

fopFMO::fopFMO(Axis & t , Axis & x, float *slowarray, float ff): 
      	fopMAP( t, x, *slowarray ){ ffn=ff; } 

fopFMO::fopFMO(Axis & ti, Axis & xi, Axis & to, Axis & xo, float slow , float ff) : 
        fopMAP( ti, xi, to, xo, slow ) { ffn=ff; } 

fopFMO::fopFMO(Axis & ti,Axis & xi,Axis & to,Axis & xo, float *slowarray,float ff):
 	fopMAP( ti, xi, to, xo, *slowarray ) { ffn=ff; } 



float fopFMO::mapping( float tau, float x ) const {

        float slowness = slow[ fopMO::inlist[0].index( tau )];

        float sx = x * slowness; float sx2 = sx*sx   ; float sx4 = sx2*sx2;
                                 float z2  = tau*tau ; float z4  = z2*z2;

        float t  = sqrt( (z4 + (1.+ffn)*z2 *sx2 + ffn*ffn*sx4)/(z2+ffn*sx2) );

        return t;
    };
