// fopmmo.h
// Operator to perform anisotropic NMO  with Francis approx.
// derived form a general MO

#ifndef _OP_FMO_F
#define _OP_FMO_F

#include <fopmap.h>
#include <fopone.h>
#include <farray.h>
#include <Axis.h>
#include <Axislist.h>
#include <math.h>

class fopFMO : public fopMAP {

    public:

    float mapping( float tau, float x ) const;

    fopFMO( Axis & t, Axis & x, float slowness, float ff);

    fopFMO( Axis & t, Axis & x, float slowarray[]  ,float ff );

    fopFMO( Axis & t, Axis & x, Axis & to, Axis & xo, float slowness , float ff);

    fopFMO( Axis & t, Axis & x, Axis & to, Axis & xo, float slowarray[] , float ff);

    protected:
    float ffn;
};

#endif

