/* Dottest.cc

   A program set up to perform the
   Dot-product test on operator fopNMO, which performs NMO. 

   The program writes to standard output
   the fractional error between the two sides of the
   Dot product test.
*/

#include <Axis.h>
#include <Axislist.h>
#include <iostream.h>
#include <fopdotprod.h>
#include <farray.h>

#include <foplmo.h>

int main() {
 
/***************************************/
	float slow=1.5;

    	cout << "\n\nDot product test, for lmo operator \n";

	    // The Axes to operate on
	Axis x(0.0,0.025,20,"x");
	Axis t(0.0,0.004,200,"t");

	    // Set up the input Axislist
    	Axislist inlist(2);
	inlist.list[0] = t;
	inlist.list[1] = x;
    

	    // Set up the output Axislist
    	Axislist outlist = inlist;

	    // Construct the operator
	fopLMO lmo(t, x, slow);

/***************************************/

	    // Call Dot-product test routine
	    // and output result
    	cout << "\n Answer is : " << fopdotprod(inlist,outlist,lmo,3) << "\n";

	return(0);
}
