/* lmo.cc
 
   lmo adj=__ vel=__ < infile.H > outfile.H

   Applies LMO operator to dataset, given velness vel.

  */
 
#include <iostream.h>
#include <SEPinit.h>
#include <Axis.h>

#include <foplmo.h>
#include <Processnew.h>

main(int argc,char **argv) {
    
    // Seplib initialization
    SepInput * sepInput = SEPinit(argc,argv,SOURCE);

    // Check that we are getting floating point data
    if( sepInput->Info()->Esize() !=4 )
	seperr("esize !=4, expecting floating point data \n");


    // Get parameters

    int adj =0;
    sepInput->Getch("adj",adj);

    int inv =0;
    sepInput->Getch("inv",inv);

    int niter =1;
    sepInput->Getch("niter",niter);

    float vel =1.5;
    sepInput->Getch("vel",vel);

    // make lmo operator
    fopLMO lmo((sepInput->Axis(1)),(sepInput->Axis(2)), 1./vel);
 
    // make input space from the seplib input
    floatspace input(sepInput);

    // Apply operator and output result
    floatspacearray output = Processnew(input, lmo, adj, inv, niter);

    // write to output
    SepOutput * sepout = new SepOutput("stdout", output(0,0).sepData() );

    delete sepout;
    UnRef(sepInput);

    return 0;
}
