/* Dottest.cc

   A program set up to perform the
   Dot-product test on operator fopNMO, which performs NMO.

   The program writes to standard output the fractional error 
   between the two sides of the Dot product test.
   */

#include <Axis.h>
#include <Axislist.h>
#include <iostream.h>
#include <fopdotprod.h>

#include <fopnmo.h>

int main() {

/**********************************/
    float vel=1.5;

    cout << "\n\nDot product test, nmo operator \n";
    cout << "vel="<<vel<<"\n";

	// The Axes to operate on
    Axis x(0.0,0.025,20,"x");
    Axis t(0.0,0.004,200,"t");

	// Set up the input Axislist
    Axislist inlist(2);
    inlist.list[0] = t; inlist.list[1]=x;

	// Output axislist is the same
    Axislist outlist = inlist;

	// Construct the operator
    fopNMO op(t,x,1.0/vel);

/***********************************/

	// Call Dot-product test routine
	// and output result
    cout << "\n Answer is : " << fopdotprod(inlist,outlist,op) << "\n";

    return(0);
}
