/* Nmo.cc
 
  Nmo adj=1 vel=1.5 <infile.H >outfile.H

  Applies NMO operator to dataset, given velocity vel.

  */
 
#include <SEPinit.h>

#include <fopnmo.h>

#include <Processnew.h>

main(int argc,char **argv) {
    
	// Seplib initialization
    SepInput * sepInput = SEPinit(argc,argv,SOURCE);

	// Check that we are getting floating point data
    if( sepInput->Info()->Esize() !=4 )
      seperr("esize !=4, expecting floating point data \n");

	// command line arguments
    int adj=0; 
    sepInput->Getch("adj",adj);

    int inv=0; 
    sepInput->Getch("inv",inv);

    int niter=5; 
    sepInput->Getch("niter",niter);

    float vel=1.5;
    sepInput->Getch("vel",vel);

	// make input space from the seplib input
    floatspace input(sepInput);

	// make NMO (assume axis1 is time and axis2 is offset )
    fopNMO op(input.getaxislist()[0], input.getaxislist()[1],1/vel);

	// Process data and output
    floatspacearray output = Processnew(input,op,adj, inv, niter );

     // write to output
    SepOutput *sepout = new SepOutput("stdout", output(0,0).sepData() );

    delete sepout;

    UnRef(sepInput);

    return 0;
}
