#include <Axis.h>
#include <fopnmo.h>

fopNMO::fopNMO(Axis & t , Axis & x, float slow): 
	fopMAP( t, x, slow ) {} 

fopNMO::fopNMO(Axis & t , Axis & x, float *slowarray): 
      	fopMAP( t, x, *slowarray ){} 

fopNMO::fopNMO(Axis & ti, Axis & xi, Axis & to, Axis & xo, float slow ) : 
        fopMAP( ti, xi, to, xo, slow ) {} 

fopNMO::fopNMO(Axis & ti, Axis & xi, Axis & to, Axis & xo, float *slowarray ) : 
        fopMAP( ti, xi, to, xo, *slowarray ) {} 

float fopNMO::mapping( float tau, float x ) const {

        float slowness = slow[ fopMO::inlist[0].index( tau )];

        float xs = x * slowness;
        float t = sqrt(tau*tau + xs*xs);

        return t;
};
